/**
 * Generated by Apache Royale Compiler from org/apache/royale/text/engine/GroupElement.as
 * org.apache.royale.text.engine.GroupElement
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.text.engine.GroupElement');

goog.require('org.apache.royale.text.engine.ContentElement');
goog.require('org.apache.royale.text.engine.TextElement');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.text.engine.ContentElement}
 * @param {Array=} elements
 * @param {org.apache.royale.text.engine.ElementFormat=} elementFormat
 * @param {org.apache.royale.events.EventDispatcher=} eventMirror
 * @param {string=} textRotation
 */
org.apache.royale.text.engine.GroupElement = function(elements, elementFormat, eventMirror, textRotation) {
  elements = typeof elements !== 'undefined' ? elements : null;
  elementFormat = typeof elementFormat !== 'undefined' ? elementFormat : null;
  eventMirror = typeof eventMirror !== 'undefined' ? eventMirror : null;
  textRotation = typeof textRotation !== 'undefined' ? textRotation : "rotate0";
  org.apache.royale.text.engine.GroupElement.base(this, 'constructor', elementFormat, eventMirror, textRotation);
  if (elements) {
    this._elements = elements;
    this.setElementsGroup(this);
  }
  else
    this._elements = org.apache.royale.utils.Language.Vector();
};
goog.inherits(org.apache.royale.text.engine.GroupElement, org.apache.royale.text.engine.ContentElement);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.text.engine.GroupElement', org.apache.royale.text.engine.GroupElement);


/**
 * @private
 * @type {Array}
 */
org.apache.royale.text.engine.GroupElement.prototype._elements;


/**
 * @export
 * @param {number} index
 * @return {org.apache.royale.text.engine.ContentElement}
 */
org.apache.royale.text.engine.GroupElement.prototype.getElementAt = function(index) {
  return this._elements[index];
};


/**
 * @export
 * @param {number} charIndex
 * @return {org.apache.royale.text.engine.ContentElement}
 */
org.apache.royale.text.engine.GroupElement.prototype.getElementAtCharIndex = function(charIndex) {
  var /** @type {number} */ curIdx = 0;
  var /** @type {number} */ len = this.elementCount;
  for (var /** @type {number} */ i = 0; i < len; i++) {
    curIdx += Number(this._elements[i].rawText.length);
    if (curIdx > charIndex)
      return this._elements[i];
  }
  return null;
};


/**
 * @export
 * @param {org.apache.royale.text.engine.ContentElement} element
 * @return {number}
 */
org.apache.royale.text.engine.GroupElement.prototype.getElementIndex = function(element) {
  return this._elements.indexOf(element);
};


/**
 * @export
 * @param {number} beginIndex
 * @param {number} endIndex
 * @return {org.apache.royale.text.engine.GroupElement}
 */
org.apache.royale.text.engine.GroupElement.prototype.groupElements = function(beginIndex, endIndex) {
  return null;
};


/**
 * @export
 * @param {number} beginIndex
 * @param {number} endIndex
 * @return {org.apache.royale.text.engine.TextElement}
 */
org.apache.royale.text.engine.GroupElement.prototype.mergeTextElements = function(beginIndex, endIndex) {
  return null;
};


/**
 * @export
 * @param {number} beginIndex
 * @param {number} endIndex
 * @param {Array} newElements
 * @return {Array}
 */
org.apache.royale.text.engine.GroupElement.prototype.replaceElements = function(beginIndex, endIndex, newElements) {
  this.setElementsGroup(null);
  
  var /** @type {Array} */ args = [beginIndex, endIndex - beginIndex];
  if (newElements)
    args = args.concat(newElements);
  this._elements.splice.apply(this._elements, args);
  this.setElementsGroup(this);
  return this._elements;
};


/**
 * @export
 * @param {Array} value
 */
org.apache.royale.text.engine.GroupElement.prototype.setElements = function(value) {
  this._elements = value;
  this.setElementsGroup(this);
};


/**
 * @private
 * @param {org.apache.royale.text.engine.GroupElement} group
 */
org.apache.royale.text.engine.GroupElement.prototype.setElementsGroup = function(group) {
  for (var /** @type {number} */ i = 0; i < this._elements.length; i++)
    this._elements[i].groupElement = group;
};


/**
 * @export
 * @param {number} elementIndex
 * @param {number} splitIndex
 * @return {org.apache.royale.text.engine.TextElement}
 */
org.apache.royale.text.engine.GroupElement.prototype.splitTextElement = function(elementIndex, splitIndex) {
  var /** @type {org.apache.royale.text.engine.ContentElement} */ elem = this._elements[elementIndex];
  if (org.apache.royale.utils.Language.is(!elem, org.apache.royale.text.engine.TextElement))
    throw new Error("Specified element is not a TextElement");
  var /** @type {org.apache.royale.text.engine.TextElement} */ textElem = org.apache.royale.utils.Language.as(elem, org.apache.royale.text.engine.TextElement);
  if (splitIndex >= textElem.rawText.length)
    throw new Error("Split index is out of range");
  var /** @type {string} */ firstText = textElem.rawText.substr(0, splitIndex);
  var /** @type {string} */ nextText = textElem.rawText.substr(splitIndex);
  var /** @type {org.apache.royale.text.engine.TextElement} */ newElem = new org.apache.royale.text.engine.TextElement(nextText, textElem.elementFormat, textElem.eventMirror, textElem.textRotation);
  textElem.text = firstText;
  newElem.groupElement = this;
  this._elements.splice(elementIndex + 1, 0, newElem);
  return newElem;
};


/**
 * @export
 * @param {number} groupIndex
 */
org.apache.royale.text.engine.GroupElement.prototype.ungroupElements = function(groupIndex) {
};


org.apache.royale.text.engine.GroupElement.prototype.get__elementCount = function() {
  return this._elements.length;
};


org.apache.royale.text.engine.GroupElement.prototype.get__rawText = function() {
  var /** @type {string} */ val = "";
  var /** @type {number} */ len = this.elementCount;
  for (var /** @type {number} */ i = 0; i < len; i++) {
    val += org.apache.royale.utils.Language.string(this._elements[i].rawText);
  }
  return val;
};


Object.defineProperties(org.apache.royale.text.engine.GroupElement.prototype, /** @lends {org.apache.royale.text.engine.GroupElement.prototype} */ {
/**
  * @export
  * @type {number} */
elementCount: {
get: org.apache.royale.text.engine.GroupElement.prototype.get__elementCount},
/**
  * @export
  * @type {string} */
rawText: {
get: org.apache.royale.text.engine.GroupElement.prototype.get__rawText}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.text.engine.GroupElement.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'GroupElement', qName: 'org.apache.royale.text.engine.GroupElement', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.text.engine.GroupElement.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'elementCount': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.text.engine.GroupElement'},
        'rawText': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.text.engine.GroupElement'}
      };
    },
    methods: function () {
      return {
        'GroupElement': { type: '', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'Vector.<org.apache.royale.text.engine.ContentElement>', optional: true },{ index: 2, type: 'org.apache.royale.text.engine.ElementFormat', optional: true },{ index: 3, type: 'org.apache.royale.events.EventDispatcher', optional: true },{ index: 4, type: 'String', optional: true } ]; }},
        'getElementAt': { type: 'org.apache.royale.text.engine.ContentElement', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'getElementAtCharIndex': { type: 'org.apache.royale.text.engine.ContentElement', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'getElementIndex': { type: 'int', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'org.apache.royale.text.engine.ContentElement', optional: false } ]; }},
        'groupElements': { type: 'org.apache.royale.text.engine.GroupElement', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false },{ index: 2, type: 'int', optional: false } ]; }},
        'mergeTextElements': { type: 'org.apache.royale.text.engine.TextElement', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false },{ index: 2, type: 'int', optional: false } ]; }},
        'replaceElements': { type: 'Vector.<org.apache.royale.text.engine.ContentElement>', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false },{ index: 2, type: 'int', optional: false },{ index: 3, type: 'Vector.<org.apache.royale.text.engine.ContentElement>', optional: false } ]; }},
        'setElements': { type: 'void', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'Vector.<org.apache.royale.text.engine.ContentElement>', optional: false } ]; }},
        'splitTextElement': { type: 'org.apache.royale.text.engine.TextElement', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false },{ index: 2, type: 'int', optional: false } ]; }},
        'ungroupElements': { type: 'void', declaredBy: 'org.apache.royale.text.engine.GroupElement', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }}
      };
    }
  };
};