/**
 * Generated by Apache Royale Compiler from org/apache/royale/text/engine/TextElement.as
 * org.apache.royale.text.engine.TextElement
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.text.engine.TextElement');

goog.require('org.apache.royale.text.engine.ContentElement');



/**
 * @constructor
 * @extends {org.apache.royale.text.engine.ContentElement}
 * @param {string=} text
 * @param {org.apache.royale.text.engine.ElementFormat=} elementFormat
 * @param {org.apache.royale.events.EventDispatcher=} eventMirror
 * @param {string=} textRotation
 */
org.apache.royale.text.engine.TextElement = function(text, elementFormat, eventMirror, textRotation) {
  text = typeof text !== 'undefined' ? text : null;
  elementFormat = typeof elementFormat !== 'undefined' ? elementFormat : null;
  eventMirror = typeof eventMirror !== 'undefined' ? eventMirror : null;
  textRotation = typeof textRotation !== 'undefined' ? textRotation : "rotate0";
  this.text = text;
  org.apache.royale.text.engine.TextElement.base(this, 'constructor', elementFormat, eventMirror, textRotation);
};
goog.inherits(org.apache.royale.text.engine.TextElement, org.apache.royale.text.engine.ContentElement);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.text.engine.TextElement', org.apache.royale.text.engine.TextElement);


/**
 * @private
 * @type {string}
 */
org.apache.royale.text.engine.TextElement.prototype._text;


/**
 * @private
 */
org.apache.royale.text.engine.TextElement.prototype.resetGlyphs = function() {
  if (this.glyphs)
    this.glyphs = null;
  this.lastComposed = -1;
};


/**
 * @private
 */
org.apache.royale.text.engine.TextElement.prototype.resetText = function() {
  if (this.words)
    this.words = null;
};


/**
 * @export
 * @param {number} beginIndex
 * @param {number} endIndex
 * @param {string} newText
 */
org.apache.royale.text.engine.TextElement.prototype.replaceText = function(beginIndex, endIndex, newText) {
  if (this._text == null)
    this._text = newText; else {
    var /** @type {string} */ b = this._text.substring(0, beginIndex);
    var /** @type {string} */ e = this._text.substring(endIndex);
    this._text = b + newText + e;
  }
  this.resetGlyphs();
  this.resetText();
};


/**
 * @export
 * @type {Array}
 */
org.apache.royale.text.engine.TextElement.prototype.glyphs;


/**
 * @export
 * @type {number}
 */
org.apache.royale.text.engine.TextElement.prototype.lastComposed = -1;


/**
 * @export
 * @type {Array}
 */
org.apache.royale.text.engine.TextElement.prototype.words;


/**
 * @export
 * @type {Array}
 */
org.apache.royale.text.engine.TextElement.prototype.wordWidths;


org.apache.royale.text.engine.TextElement.prototype.get__text = function() {
  return this._text;
};


org.apache.royale.text.engine.TextElement.prototype.set__text = function(value) {
  this._text = value;
  this.resetGlyphs();
  this.resetText();
};


org.apache.royale.text.engine.TextElement.prototype.get__rawText = function() {
  return this._text;
};


org.apache.royale.text.engine.TextElement.prototype.set__elementFormat = function(value) {
  org.apache.royale.text.engine.TextElement.superClass_.set__elementFormat.apply(this, [ value] );
  this.resetGlyphs();
  this.resetText();
};


Object.defineProperties(org.apache.royale.text.engine.TextElement.prototype, /** @lends {org.apache.royale.text.engine.TextElement.prototype} */ {
/**
  * @export
  * @type {string} */
text: {
get: org.apache.royale.text.engine.TextElement.prototype.get__text,
set: org.apache.royale.text.engine.TextElement.prototype.set__text},
/**
  * @export
  * @type {string} */
rawText: {
get: org.apache.royale.text.engine.TextElement.prototype.get__rawText},
/**
  * @export
  * @type {org.apache.royale.text.engine.ElementFormat} */
elementFormat: {
get: org.apache.royale.text.engine.ContentElement.prototype.get__elementFormat,
set: org.apache.royale.text.engine.TextElement.prototype.set__elementFormat}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.text.engine.TextElement.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'TextElement', qName: 'org.apache.royale.text.engine.TextElement', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.text.engine.TextElement.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'glyphs': { type: 'Array'},
        'lastComposed': { type: 'int'},
        'words': { type: 'Array'},
        'wordWidths': { type: 'Array'}
      };
    },
    accessors: function () {
      return {
        'text': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.text.engine.TextElement'},
        'rawText': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.text.engine.TextElement'},
        'elementFormat': { type: 'org.apache.royale.text.engine.ElementFormat', access: 'writeonly', declaredBy: 'org.apache.royale.text.engine.TextElement'}
      };
    },
    methods: function () {
      return {
        'TextElement': { type: '', declaredBy: 'org.apache.royale.text.engine.TextElement', parameters: function () { return [  { index: 1, type: 'String', optional: true },{ index: 2, type: 'org.apache.royale.text.engine.ElementFormat', optional: true },{ index: 3, type: 'org.apache.royale.events.EventDispatcher', optional: true },{ index: 4, type: 'String', optional: true } ]; }},
        'replaceText': { type: 'void', declaredBy: 'org.apache.royale.text.engine.TextElement', parameters: function () { return [  { index: 1, type: 'int', optional: false },{ index: 2, type: 'int', optional: false },{ index: 3, type: 'String', optional: false } ]; }}
      };
    }
  };
};