/**
 * Generated by Apache Royale Compiler from org/apache/royale/text/html/TextBlock.as
 * org.apache.royale.text.html.TextBlock
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.text.html.TextBlock');

goog.require('org.apache.royale.html.elements.Span');
goog.require('org.apache.royale.text.engine.TextElement');
goog.require('org.apache.royale.text.html.TextLine');
goog.require('org.apache.royale.text.engine.ITextBlock');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.text.engine.ITextBlock}
 * @param {org.apache.royale.text.engine.ITextFactory} factory
 */
org.apache.royale.text.html.TextBlock = function(factory) {
  
  this.lines = [];
  this._textFactory = factory;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.text.html.TextBlock', org.apache.royale.text.html.TextBlock);


/**
 * @private
 * @type {org.apache.royale.text.engine.ITextFactory}
 */
org.apache.royale.text.html.TextBlock.prototype._textFactory;


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.text.html.TextBlock.prototype._applyNonLinearFontScaling;


/**
 * @private
 * @type {org.apache.royale.text.engine.FontDescription}
 */
org.apache.royale.text.html.TextBlock.prototype._baselineFontDescription;


/**
 * @private
 * @type {number}
 */
org.apache.royale.text.html.TextBlock.prototype._baselineFontSize = 12;


/**
 * @private
 * @type {string}
 */
org.apache.royale.text.html.TextBlock.prototype._baselineZero = "roman";


/**
 * @private
 * @type {number}
 */
org.apache.royale.text.html.TextBlock.prototype._bidiLevel = 0;


/**
 * @private
 * @type {org.apache.royale.text.engine.ContentElement}
 */
org.apache.royale.text.html.TextBlock.prototype._content;


/**
 * @private
 * @type {org.apache.royale.text.engine.ITextLine}
 */
org.apache.royale.text.html.TextBlock.prototype._firstInvalidLine;


/**
 * @private
 * @type {org.apache.royale.text.engine.ITextLine}
 */
org.apache.royale.text.html.TextBlock.prototype._firstLine;


/**
 * @private
 * @type {org.apache.royale.text.engine.ITextLine}
 */
org.apache.royale.text.html.TextBlock.prototype._lastLine;


/**
 * @private
 * @type {string}
 */
org.apache.royale.text.html.TextBlock.prototype._lineRotation;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.text.html.TextBlock.prototype._tabStops;


/**
 * @private
 * @type {org.apache.royale.text.engine.TextJustifier}
 */
org.apache.royale.text.html.TextBlock.prototype._textJustifier;


/**
 * @private
 * @type {string}
 */
org.apache.royale.text.html.TextBlock.prototype._textLineCreationResult;


/**
 * @private
 * @type {*}
 */
org.apache.royale.text.html.TextBlock.prototype._userData;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.text.html.TextBlock.prototype.lines;


/**
 * @royaleignorecoercion org.apache.royale.core.IParent
 * @export
 * @param {org.apache.royale.text.engine.ITextLine=} previousLine
 * @param {number=} width
 * @param {number=} lineOffset
 * @param {boolean=} fitSomething
 * @return {org.apache.royale.text.engine.ITextLine}
 */
org.apache.royale.text.html.TextBlock.prototype.createTextLine = function(previousLine, width, lineOffset, fitSomething) {
  previousLine = typeof previousLine !== 'undefined' ? previousLine : null;
  width = typeof width !== 'undefined' ? width : 1000000;
  lineOffset = typeof lineOffset !== 'undefined' ? lineOffset : 0.0;
  fitSomething = typeof fitSomething !== 'undefined' ? fitSomething : false;
  if (previousLine == null)
    this.lines.length = 0;
  var /** @type {org.apache.royale.text.engine.TextElement} */ textElem = org.apache.royale.utils.Language.as(this.content, org.apache.royale.text.engine.TextElement);
  var /** @type {org.apache.royale.text.engine.ElementFormat} */ format = this.content.elementFormat;
  var /** @type {org.apache.royale.text.html.TextLine} */ tl = new org.apache.royale.text.html.TextLine(this, previousLine ? previousLine.textBlockBeginIndex + previousLine.rawTextLength : 0);
  
  this.textFactory.currentContainer.addElement(tl);
  var /** @type {org.apache.royale.html.elements.Span} */ span = new org.apache.royale.html.elements.Span();
  span.text = textElem.text;
  tl.addElement(span);
  this.lines.push(tl);
  if (previousLine == null)
    this._firstLine = tl;
  this._lastLine = tl;
  return tl;
};


/**
 * @export
 * @return {string}
 */
org.apache.royale.text.html.TextBlock.prototype.dump = function() {
  return null;
};


/**
 * @export
 * @param {number} afterCharIndex
 * @return {number}
 */
org.apache.royale.text.html.TextBlock.prototype.findNextAtomBoundary = function(afterCharIndex) {
  return afterCharIndex + 1;
};


/**
 * @export
 * @param {number} afterCharIndex
 * @return {number}
 */
org.apache.royale.text.html.TextBlock.prototype.findNextWordBoundary = function(afterCharIndex) {
  org.apache.royale.utils.Language.trace("findNextWordBoundary not implemented");
  return 0;
};


/**
 * @export
 * @param {number} beforeCharIndex
 * @return {number}
 */
org.apache.royale.text.html.TextBlock.prototype.findPreviousAtomBoundary = function(beforeCharIndex) {
  return beforeCharIndex - 1;
};


/**
 * @export
 * @param {number} beforeCharIndex
 * @return {number}
 */
org.apache.royale.text.html.TextBlock.prototype.findPreviousWordBoundary = function(beforeCharIndex) {
  org.apache.royale.utils.Language.trace("findPreviousWordBoundary not implemented");
  return 0;
};


/**
 * @export
 * @param {number} charIndex
 * @return {org.apache.royale.text.engine.ITextLine}
 */
org.apache.royale.text.html.TextBlock.prototype.getTextLineAtCharIndex = function(charIndex) {
  var /** @type {number} */ lineIndex = 0;
  var foreachiter0_target = this.lines;
  for (var foreachiter0 in foreachiter0_target) 
  {
  var line = foreachiter0_target[foreachiter0];
  {
    
    lineIndex += line.element.firstChild.textContent.length;
    if (lineIndex > charIndex)
      return line;
  }}
  
  return null;
};


/**
 * @export
 * @param {org.apache.royale.text.engine.ITextLine} textLine
 * @param {org.apache.royale.text.engine.ITextLine=} previousLine
 * @param {number=} width
 * @param {number=} lineOffset
 * @param {boolean=} fitSomething
 * @return {org.apache.royale.text.engine.ITextLine}
 */
org.apache.royale.text.html.TextBlock.prototype.recreateTextLine = function(textLine, previousLine, width, lineOffset, fitSomething) {
  previousLine = typeof previousLine !== 'undefined' ? previousLine : null;
  width = typeof width !== 'undefined' ? width : 1000000;
  lineOffset = typeof lineOffset !== 'undefined' ? lineOffset : 0.0;
  fitSomething = typeof fitSomething !== 'undefined' ? fitSomething : false;
  org.apache.royale.utils.Language.trace("recreateTextLine not implemented");
  return null;
};


/**
 * @export
 */
org.apache.royale.text.html.TextBlock.prototype.releaseLineCreationData = function() {
};


/**
 * @export
 * @param {org.apache.royale.text.engine.ITextLine} firstLine
 * @param {org.apache.royale.text.engine.ITextLine} lastLine
 */
org.apache.royale.text.html.TextBlock.prototype.releaseLines = function(firstLine, lastLine) {
  this.lines.length = 0;
};


/**
 * @export
 * @param {org.apache.royale.text.engine.ContentElement} element
 * @return {number}
 */
org.apache.royale.text.html.TextBlock.prototype.getRelativeStart = function(element) {
  return 0;
};


org.apache.royale.text.html.TextBlock.prototype.get__textFactory = function() {
  return this._textFactory;
};


org.apache.royale.text.html.TextBlock.prototype.get__applyNonLinearFontScaling = function() {
  return this._applyNonLinearFontScaling;
};


org.apache.royale.text.html.TextBlock.prototype.set__applyNonLinearFontScaling = function(value) {
  this._applyNonLinearFontScaling = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__baselineFontDescription = function() {
  return this._baselineFontDescription;
};


org.apache.royale.text.html.TextBlock.prototype.set__baselineFontDescription = function(value) {
  this._baselineFontDescription = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__baselineFontSize = function() {
  return this._baselineFontSize;
};


org.apache.royale.text.html.TextBlock.prototype.set__baselineFontSize = function(value) {
  this._baselineFontSize = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__baselineZero = function() {
  return this._baselineZero;
};


org.apache.royale.text.html.TextBlock.prototype.set__baselineZero = function(value) {
  this._baselineZero = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__bidiLevel = function() {
  return this._bidiLevel;
};


org.apache.royale.text.html.TextBlock.prototype.set__bidiLevel = function(value) {
  this._bidiLevel = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__content = function() {
  return this._content;
};


org.apache.royale.text.html.TextBlock.prototype.set__content = function(value) {
  this._content = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__firstInvalidLine = function() {
  return this._firstInvalidLine;
};


org.apache.royale.text.html.TextBlock.prototype.set__firstInvalidLine = function(value) {
  this._firstInvalidLine = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__firstLine = function() {
  return this._firstLine;
};


org.apache.royale.text.html.TextBlock.prototype.set__firstLine = function(value) {
  this._firstLine = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__lastLine = function() {
  return this._lastLine;
};


org.apache.royale.text.html.TextBlock.prototype.set__lastLine = function(value) {
  this._lastLine = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__lineRotation = function() {
  return this._lineRotation;
};


org.apache.royale.text.html.TextBlock.prototype.set__lineRotation = function(value) {
  this._lineRotation = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__tabStops = function() {
  return this._tabStops;
};


org.apache.royale.text.html.TextBlock.prototype.set__tabStops = function(value) {
  this._tabStops = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__textJustifier = function() {
  return this._textJustifier;
};


org.apache.royale.text.html.TextBlock.prototype.set__textJustifier = function(value) {
  this._textJustifier = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__textLineCreationResult = function() {
  return this._textLineCreationResult;
};


org.apache.royale.text.html.TextBlock.prototype.set__textLineCreationResult = function(value) {
  this._textLineCreationResult = value;
};


org.apache.royale.text.html.TextBlock.prototype.get__userData = function() {
  return this._userData;
};


org.apache.royale.text.html.TextBlock.prototype.set__userData = function(value) {
  this._userData = value;
};


Object.defineProperties(org.apache.royale.text.html.TextBlock.prototype, /** @lends {org.apache.royale.text.html.TextBlock.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.text.engine.ITextFactory} */
textFactory: {
get: org.apache.royale.text.html.TextBlock.prototype.get__textFactory},
/**
  * @export
  * @type {boolean} */
applyNonLinearFontScaling: {
get: org.apache.royale.text.html.TextBlock.prototype.get__applyNonLinearFontScaling,
set: org.apache.royale.text.html.TextBlock.prototype.set__applyNonLinearFontScaling},
/**
  * @export
  * @type {org.apache.royale.text.engine.FontDescription} */
baselineFontDescription: {
get: org.apache.royale.text.html.TextBlock.prototype.get__baselineFontDescription,
set: org.apache.royale.text.html.TextBlock.prototype.set__baselineFontDescription},
/**
  * @export
  * @type {number} */
baselineFontSize: {
get: org.apache.royale.text.html.TextBlock.prototype.get__baselineFontSize,
set: org.apache.royale.text.html.TextBlock.prototype.set__baselineFontSize},
/**
  * @export
  * @type {string} */
baselineZero: {
get: org.apache.royale.text.html.TextBlock.prototype.get__baselineZero,
set: org.apache.royale.text.html.TextBlock.prototype.set__baselineZero},
/**
  * @export
  * @type {number} */
bidiLevel: {
get: org.apache.royale.text.html.TextBlock.prototype.get__bidiLevel,
set: org.apache.royale.text.html.TextBlock.prototype.set__bidiLevel},
/**
  * @export
  * @type {org.apache.royale.text.engine.ContentElement} */
content: {
get: org.apache.royale.text.html.TextBlock.prototype.get__content,
set: org.apache.royale.text.html.TextBlock.prototype.set__content},
/**
  * @export
  * @type {org.apache.royale.text.engine.ITextLine} */
firstInvalidLine: {
get: org.apache.royale.text.html.TextBlock.prototype.get__firstInvalidLine,
set: org.apache.royale.text.html.TextBlock.prototype.set__firstInvalidLine},
/**
  * @export
  * @type {org.apache.royale.text.engine.ITextLine} */
firstLine: {
get: org.apache.royale.text.html.TextBlock.prototype.get__firstLine,
set: org.apache.royale.text.html.TextBlock.prototype.set__firstLine},
/**
  * @export
  * @type {org.apache.royale.text.engine.ITextLine} */
lastLine: {
get: org.apache.royale.text.html.TextBlock.prototype.get__lastLine,
set: org.apache.royale.text.html.TextBlock.prototype.set__lastLine},
/**
  * @export
  * @type {string} */
lineRotation: {
get: org.apache.royale.text.html.TextBlock.prototype.get__lineRotation,
set: org.apache.royale.text.html.TextBlock.prototype.set__lineRotation},
/**
  * @export
  * @type {Vector.<TabStop>} */
tabStops: {
get: org.apache.royale.text.html.TextBlock.prototype.get__tabStops,
set: org.apache.royale.text.html.TextBlock.prototype.set__tabStops},
/**
  * @export
  * @type {org.apache.royale.text.engine.TextJustifier} */
textJustifier: {
get: org.apache.royale.text.html.TextBlock.prototype.get__textJustifier,
set: org.apache.royale.text.html.TextBlock.prototype.set__textJustifier},
/**
  * @export
  * @type {string} */
textLineCreationResult: {
get: org.apache.royale.text.html.TextBlock.prototype.get__textLineCreationResult,
set: org.apache.royale.text.html.TextBlock.prototype.set__textLineCreationResult},
/**
  * @export
  * @type {*} */
userData: {
get: org.apache.royale.text.html.TextBlock.prototype.get__userData,
set: org.apache.royale.text.html.TextBlock.prototype.set__userData}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.text.html.TextBlock.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'TextBlock', qName: 'org.apache.royale.text.html.TextBlock', kind: 'class' }], interfaces: [org.apache.royale.text.engine.ITextBlock] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.text.html.TextBlock.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'textFactory': { type: 'org.apache.royale.text.engine.ITextFactory', access: 'readonly', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'applyNonLinearFontScaling': { type: 'Boolean', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'baselineFontDescription': { type: 'org.apache.royale.text.engine.FontDescription', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'baselineFontSize': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'baselineZero': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'bidiLevel': { type: 'int', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'content': { type: 'org.apache.royale.text.engine.ContentElement', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'firstInvalidLine': { type: 'org.apache.royale.text.engine.ITextLine', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'firstLine': { type: 'org.apache.royale.text.engine.ITextLine', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'lastLine': { type: 'org.apache.royale.text.engine.ITextLine', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'lineRotation': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'tabStops': { type: 'Vector.<org.apache.royale.text.engine.TabStop>', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'textJustifier': { type: 'org.apache.royale.text.engine.TextJustifier', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'textLineCreationResult': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'userData': { type: '*', access: 'readwrite', declaredBy: 'org.apache.royale.text.html.TextBlock'}
      };
    },
    methods: function () {
      return {
        'TextBlock': { type: '', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'org.apache.royale.text.engine.ITextFactory', optional: false } ]; }},
        'createTextLine': { type: 'org.apache.royale.text.engine.ITextLine', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'org.apache.royale.text.engine.ITextLine', optional: true },{ index: 2, type: 'Number', optional: true },{ index: 3, type: 'Number', optional: true },{ index: 4, type: 'Boolean', optional: true } ]; }},
        'dump': { type: 'String', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'findNextAtomBoundary': { type: 'int', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'findNextWordBoundary': { type: 'int', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'findPreviousAtomBoundary': { type: 'int', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'findPreviousWordBoundary': { type: 'int', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'getTextLineAtCharIndex': { type: 'org.apache.royale.text.engine.ITextLine', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'recreateTextLine': { type: 'org.apache.royale.text.engine.ITextLine', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'org.apache.royale.text.engine.ITextLine', optional: false },{ index: 2, type: 'org.apache.royale.text.engine.ITextLine', optional: true },{ index: 3, type: 'Number', optional: true },{ index: 4, type: 'Number', optional: true },{ index: 5, type: 'Boolean', optional: true } ]; }},
        'releaseLineCreationData': { type: 'void', declaredBy: 'org.apache.royale.text.html.TextBlock'},
        'releaseLines': { type: 'void', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'org.apache.royale.text.engine.ITextLine', optional: false },{ index: 2, type: 'org.apache.royale.text.engine.ITextLine', optional: false } ]; }},
        'getRelativeStart': { type: 'int', declaredBy: 'org.apache.royale.text.html.TextBlock', parameters: function () { return [  { index: 1, type: 'org.apache.royale.text.engine.ContentElement', optional: false } ]; }}
      };
    }
  };
};